import 'package:flutter/material.dart';
import 'dart:async';
import 'package:sql_query/query.dart';
import 'package:sql_query/viewer/controller/sql_viewer_controller.dart';
import 'package:sql_query_example/produk.dart';
import 'package:sql_query_example/satuan.dart';

final navigatorKey = GlobalKey<NavigatorState>();

void main() async {
  WidgetsFlutterBinding.ensureInitialized();
  await DB.init(
    databaseName: 'testing',
    tableList: [
      Produk.tables(),
      Satuan.tables(),
    ],
  );
  // await Merger.init();
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    super.initState();

    Future.delayed(Duration.zero, () async {
      // await Produk.add();
      // print(await Produk.get());
      SQL.view(isFirst: true, context: navigatorKey.currentContext!);
    });
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {}

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      navigatorKey: navigatorKey,
      home: const Scaffold(),
    );
  }
}
