import 'package:flutter/material.dart';
import 'package:sql_query/query.dart';
import 'package:sql_query/viewer/part/button.dart';

import '../model/auto_model.dart';
import '../model/sql_master_model.dart';
import '../part/form.dart';
import '../part/main_view.dart';

class SQL {
  static SQLMasterModel? selectedTable;
  static List<TableDatabase> listTableDatabase = [];
  static DBMerge? _dataMerge;
  static TableDatabase? globalData;
  static Fresh<int> menuActive = Fresh(0);
  static Fresh<List<SQLMasterModel>> dataTable = Fresh([]);
  static List<Widget> buildTableRow = [];
  static List showedData = [];
  static int? maxData;

  static selectTable(SQLMasterModel table) async {
    maxData = 0;
    globalData = null;
    dataTable.refresh((listener) => selectedTable = table);
    if (menuActive.value == 1) {
      getTableRow();
    }
    // print(await DB.table(selectedTable?.tableName ?? '').get());
  }

  static getTableRow() async {
    buildTableRow = [];
    showedData = [];
    final getDataColumn = SQL.listTableDatabase.where((element) => element.tableName == SQL.selectedTable?.tableName);
    TableDatabase? data;
    if (getDataColumn.isNotEmpty) {
      data = getDataColumn.first;
      globalData = data;
    }
    if (data != null) {
      final getData = _dataMerge != null ? await _dataMerge!.table(data.tableName).limit(50).get() : await DB.table(data.tableName).limit(50).get();

      maxData = getData.length;
      for (var i in data.column) {
        if (i.primaryKey) {
          for (var j in getData) {
            showedData.add(j[i.name]);
          }
        }
        final List<Widget> buildTableRowIn = [];
        buildTableRowIn.add(
          Padding(
            padding: const EdgeInsets.only(bottom: 8.0),
            child: Container(
              padding: const EdgeInsets.symmetric(horizontal: 20, vertical: 12),
              decoration: BoxDecoration(
                color: const Color(0xffF8F8F8),
                borderRadius: BorderRadius.circular(7),
                border: Border.all(color: Colors.black26, width: 1),
              ),
              child: Row(
                children: [
                  Expanded(child: Text(i.name)),
                ],
              ),
            ),
          ),
        );
        for (var j in getData) {
          buildTableRowIn.add(
            Padding(
              padding: const EdgeInsets.only(bottom: 8.0),
              child: Container(
                padding: const EdgeInsets.symmetric(horizontal: 20, vertical: 12),
                decoration: BoxDecoration(
                  color: const Color(0xffF8F8F8),
                  borderRadius: BorderRadius.circular(7),
                  border: Border.all(color: Colors.black26, width: 1),
                ),
                child: Row(
                  children: [
                    Expanded(
                      child: Text(
                        j[i.name].toString(),
                      ),
                    ),
                  ],
                ),
              ),
            ),
          );
        }

        buildTableRow.add(
          Padding(
            padding: const EdgeInsets.only(right: 8.0),
            child: IntrinsicWidth(
              child: Column(
                children: buildTableRowIn.toList(),
              ),
            ),
          ),
        );
      }
    }
    dataTable.refresh((listener) => null);
  }

  static showAddModal(context) {
    List<MaterialXFormController> controller = [];
    List<Widget> buildWidget = [];

    for (final ColumnDatabase i in globalData?.column ?? []) {
      final cont = MaterialXFormController(
        isRequired: i.primaryKey && i.autoIncrement ? false : !i.isNull,
      );
      controller.add(cont);
      buildWidget.add(
        Padding(
          padding: const EdgeInsets.only(bottom: 12),
          child: MaterialXForm(
            title: i.name,
            hintText: i.primaryKey && i.autoIncrement
                ? 'Auto Incement'
                : i.isNull
                    ? '(Optional)'
                    : '(Required)',
            controller: cont,
            isEnabled: !(i.primaryKey && i.autoIncrement),
            isNumber: !(i.typeData == DataType.text),
          ),
        ),
      );
    }

    showModalBottomSheet(
        context: context,
        backgroundColor: Colors.transparent,
        isScrollControlled: true,
        builder: (context) {
          return bottom(
            context: context,
            maxHeight: 0.9,
            child: StatefulBuilder(builder: (context, s) {
              return Column(
                children: [
                  Column(
                    children: buildWidget.toList(),
                  ),
                  MaterialXButton(
                    onTap: () {
                      final error = controller.where((element) => element.controller!.text == '' && element.isRequired);
                      if (error.isNotEmpty) {
                        error.map((e) => e.status = FormStatus.error);
                        s(() {});
                        return;
                      } else {
                        final Map<String, String> map = {};
                        for (int i = 0; i < (globalData?.column ?? []).length; i++) {
                          final ColumnDatabase data = globalData!.column[i];
                          if (controller[i].controller?.text != '') {
                            map.addAll({
                              data.name: controller[i].controller?.text ?? '',
                            });
                          }
                        }
                        if (_dataMerge != null) {
                          _dataMerge!.table(globalData!.tableName).listData([map]).insert().then((value) {
                                getTableRow();
                              });
                        } else {
                          DB.table(globalData!.tableName).listData([map]).insert().then((value) {
                                getTableRow();
                              });
                        }
                        Navigator.pop(context);
                      }
                    },
                    title: 'Add',
                  )
                ],
              );
            }),
          );
        }).then(
      (value) => Future.delayed(
        const Duration(milliseconds: 800),
        () {
          for (var i in controller) {
            i.controller?.dispose();
          }
        },
      ),
    );
  }

  static view({isFirst = false, DBMerge? dbMerge, BuildContext? context}) async {
    if (isFirst) {
      dataTable = Fresh([]);
    }
    if (dbMerge != null) {
      _dataMerge = dbMerge;
      _buildData(await _dataMerge!.table('sqlite_master').orderBy(['name ASC']).get());
      _buildTable(await _dataMerge!.table('_sql_query_tables').get());
    } else {
      _buildData(await DB.table('sqlite_master').orderBy(['name ASC']).get());
      _buildTable(await DB.table('_sql_query_tables').get());
    }
    if (isFirst && context != null) {
      Navigator.push(context, MaterialPageRoute(builder: (b) => const SQLViewer()));
    }
  }

  static delete(id) async {
    if (_dataMerge != null) {
      _buildTable(await _dataMerge!.table('_sql_query_tables').get());
    } else {
      DB.table(globalData!.tableName).where(globalData!.column.where((element) => element.primaryKey).first.name, '=', id.toString()).delete().then((value) => getTableRow());
    }
  }

  static refresh() async {
    selectedTable = null;
    await view(dbMerge: _dataMerge);
  }

  static _buildTable(data) {
    listTableDatabase = [];
    for (var i in data) {
      final configParse = i['config'].toString().split('|');
      if (listTableDatabase.where((element) => element.tableName == i['name_table']).isNotEmpty) {
        listTableDatabase.where((element) => element.tableName == i['name_table']).first.column.add(ColumnDatabase(name: i['name_column'], typeData: ColumnDatabase.typeDataParse(configParse[0]), isNull: configParse[1] == 'true', defaultValue: configParse[2] == 'null' ? null : configParse[2], autoIncrement: i['is_ai'] == 1, primaryKey: i['is_primary'] == 1));
      } else {
        listTableDatabase.add(TableDatabase(
          column: [ColumnDatabase(name: i['name_column'], typeData: ColumnDatabase.typeDataParse(configParse[0]), isNull: configParse[1] == 'true', defaultValue: configParse[2] == 'null' ? null : configParse[2], autoIncrement: i['is_ai'] == 1, primaryKey: i['is_primary'] == 1)],
          tableName: i['name_table'],
        ));
      }
    }
  }

  static _buildData(List data) {
    dataTable.value.clear();
    dataTable.refresh((listener) => null);
    for (var i in data.where((element) => element['tbl_name'][0] != '_').toList()) {
      dataTable.value.add(SQLMasterModel.build(i));
    }
    dataTable.refresh((listener) => null);
  }

  static dispose() {
    dataTable.value.clear();
    dataTable.dispose();
  }
}
