import 'package:flutter/material.dart';
import 'package:flutter_feather_icons/flutter_feather_icons.dart';
import '../controller/sql_viewer_controller.dart';
import '../model/auto_model.dart';
import 'button.dart';

class DataMenuPart extends StatelessWidget {
  const DataMenuPart({super.key});

  @override
  Widget build(BuildContext context) {
    return Fresher(
      listener: SQL.dataTable,
      builder: (v) {
        return InteractiveViewer(
          constrained: false,
          alignment: Alignment.centerLeft,
          child: Padding(
            padding: const EdgeInsets.symmetric(horizontal: 20.0),
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Row(
                  children: [
                    MaterialXButton(
                      onTap: () {
                        SQL.showAddModal(context);
                      },
                      title: 'Tambah Data',
                    )
                  ],
                ),
                const SizedBox(
                  height: 20,
                ),
                SQL.maxData == null
                    ? const SizedBox()
                    : Row(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: [
                          Row(
                            children: SQL.buildTableRow.toList(),
                          ),
                          Column(
                            children: [
                              const SizedBox(
                                height: 48,
                                width: 10,
                              ),
                              for (int i = 0; i < (SQL.maxData ?? 0); i++)
                                NoSplashButton(
                                  onTap: () {
                                    final id = SQL.showedData[i];
                                    SQL.delete(id);
                                  },
                                  child: const SizedBox(
                                    height: 48,
                                    child: Center(
                                      child: Icon(FeatherIcons.trash),
                                    ),
                                  ),
                                ),
                            ],
                          )
                        ],
                      ),
              ],
            ),
          ),
        );
      },
    );
  }
}
