import 'package:flutter/material.dart';
import 'package:sql_query/viewer/part/button.dart';
import 'package:sql_query/viewer/part/sidebar.dart';
import 'package:sql_query/viewer/part/table_part.dart';

import '../controller/sql_viewer_controller.dart';
import '../model/auto_model.dart';
import 'data_part.dart';

final globalK = GlobalKey<ScaffoldState>();

class SQLViewer extends StatelessWidget {
  const SQLViewer({super.key});

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      key: globalK,
      drawer: const Sidebar(),
      body: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          SizedBox(
            height: 85,
            child: Row(
              children: [
                GestureDetector(
                  onTap: () {
                    globalK.currentState!.openDrawer();
                  },
                  child: Container(
                    padding: const EdgeInsets.only(top: 40, left: 20, right: 20, bottom: 20),
                    decoration: const BoxDecoration(
                      color: Color(0xff2463C2),
                      borderRadius: BorderRadius.only(bottomRight: Radius.circular(40)),
                    ),
                    child: const Icon(
                      Icons.account_tree_outlined,
                      color: Colors.white,
                    ),
                  ),
                ),
                const SizedBox(
                  width: 12,
                ),
                Expanded(
                    child: Column(
                  children: [
                    const SizedBox(
                      height: 25,
                    ),
                    Expanded(
                      child: Fresher<int>(
                        listener: SQL.menuActive,
                        builder: (menu) {
                          return Row(
                            children: [
                              NoSplashButton(
                                onTap: () {
                                  SQL.menuActive.refresh((listener) => listener.value = 0);
                                },
                                child: Row(
                                  children: [
                                    IntrinsicWidth(
                                      child: Column(
                                        children: [
                                          const Expanded(child: SizedBox()),
                                          const Padding(
                                            padding: EdgeInsets.symmetric(horizontal: 12),
                                            child: Text('Table'),
                                          ),
                                          const Expanded(child: SizedBox()),
                                          Container(
                                            height: 4,
                                            decoration: BoxDecoration(
                                                color: menu != 0 ? Colors.transparent : const Color(0xff2463C2),
                                                borderRadius: const BorderRadius.only(
                                                  topLeft: Radius.circular(6),
                                                  topRight: Radius.circular(6),
                                                )),
                                          )
                                        ],
                                      ),
                                    ),
                                  ],
                                ),
                              ),
                              const SizedBox(
                                width: 12,
                              ),
                              NoSplashButton(
                                onTap: () {
                                  SQL.getTableRow();
                                  SQL.menuActive.refresh((listener) => listener.value = 1);
                                },
                                child: Row(
                                  children: [
                                    IntrinsicWidth(
                                      child: Column(
                                        children: [
                                          const Expanded(child: SizedBox()),
                                          const Padding(
                                            padding: EdgeInsets.symmetric(horizontal: 12),
                                            child: Text('Data'),
                                          ),
                                          const Expanded(child: SizedBox()),
                                          Container(
                                            height: 4,
                                            decoration: BoxDecoration(
                                                color: menu != 1 ? Colors.transparent : const Color(0xff2463C2),
                                                borderRadius: const BorderRadius.only(
                                                  topLeft: Radius.circular(6),
                                                  topRight: Radius.circular(6),
                                                )),
                                          )
                                        ],
                                      ),
                                    ),
                                  ],
                                ),
                              ),
                              const SizedBox(
                                width: 12,
                              ),
                              NoSplashButton(
                                onTap: () {
                                  SQL.menuActive.refresh((listener) => listener.value = 2);
                                },
                                child: Row(
                                  children: [
                                    IntrinsicWidth(
                                      child: Column(
                                        children: [
                                          const Expanded(child: SizedBox()),
                                          const Padding(
                                            padding: EdgeInsets.symmetric(horizontal: 12),
                                            child: Text(
                                              'Relation\n(comming soon)',
                                              textAlign: TextAlign.center,
                                            ),
                                          ),
                                          const Expanded(child: SizedBox()),
                                          Container(
                                            height: 4,
                                            decoration: BoxDecoration(
                                                color: menu != 2 ? Colors.transparent : const Color(0xff2463C2),
                                                borderRadius: const BorderRadius.only(
                                                  topLeft: Radius.circular(6),
                                                  topRight: Radius.circular(6),
                                                )),
                                          )
                                        ],
                                      ),
                                    ),
                                  ],
                                ),
                              ),
                            ],
                          );
                        },
                      ),
                    ),
                  ],
                ))
              ],
            ),
          ),
          const SizedBox(
            height: 30,
          ),
          Expanded(
            child: Fresher<int>(
                listener: SQL.menuActive,
                builder: (menu) {
                  if (menu == 0) {
                    return const TableMenuPart();
                  } else if (menu == 1) {
                    return const DataMenuPart();
                  } else if (menu == 2) {
                    return const Center(
                      child: Text('Comming Soon'),
                    );
                  }
                  return const SizedBox();
                }),
          ),
        ],
      ),
    );
  }
}
